#pragma once

#include <ostream>

#include <engine/types.h>

namespace engine::input {
enum class Key : u16
{
  KeyReserved = 0x0000,
  KeyEscape = 0x0001,
  Key1 = 0x0002,
  Key2 = 0x0003,
  Key3 = 0x0004,
  Key4 = 0x0005,
  Key5 = 0x0006,
  Key6 = 0x0007,
  Key7 = 0x0008,
  Key8 = 0x0009,
  Key9 = 0x000a,
  Key0 = 0x000b,
  KeyMinus = 0x000c,
  KeyEqual = 0x000d,
  KeyBackspace = 0x000e,
  KeyTab = 0x000f,
  KeyQ = 0x0010,
  KeyW = 0x0011,
  KeyE = 0x0012,
  KeyR = 0x0013,
  KeyT = 0x0014,
  KeyY = 0x0015,
  KeyU = 0x0016,
  KeyI = 0x0017,
  KeyO = 0x0018,
  KeyP = 0x0019,
  KeyLeftBrace = 0x001a,
  KeyRightBrace = 0x001b,
  KeyEnter = 0x001c,
  KeyLeftControl = 0x001d,
  KeyA = 0x001e,
  KeyS = 0x001f,
  KeyD = 0x0020,
  KeyF = 0x0021,
  KeyG = 0x0022,
  KeyH = 0x0023,
  KeyJ = 0x0024,
  KeyK = 0x0025,
  KeyL = 0x0026,
  KeySemicolon = 0x0027,
  KeyApostrophe = 0x0028,
  KeyGrave = 0x0029,
  KeyLeftShift = 0x002a,
  KeyBackslash = 0x002b,
  KeyZ = 0x002c,
  KeyX = 0x002d,
  KeyC = 0x002e,
  KeyV = 0x002f,
  KeyB = 0x0030,
  KeyN = 0x0031,
  KeyM = 0x0032,
  KeyComma = 0x0033,
  KeyDot = 0x0034,
  KeySlash = 0x0035,
  KeyRightShift = 0x0036,
  KeyKeypadAsterisk = 0x0037,
  KeyLeftAlternate = 0x0038,
  KeySpace = 0x0039,
  KeyCapsLock = 0x003a,
  KeyF1 = 0x003b,
  KeyF2 = 0x003c,
  KeyF3 = 0x003d,
  KeyF4 = 0x003e,
  KeyF5 = 0x003f,
  KeyF6 = 0x0040,
  KeyF7 = 0x0041,
  KeyF8 = 0x0042,
  KeyF9 = 0x0043,
  KeyF10 = 0x0044,
  KeyNumericLock = 0x0045,
  KeyScrollLock = 0x0046,
  KeyKeypad7 = 0x0047,
  KeyKeypad8 = 0x0048,
  KeyKeypad9 = 0x0049,
  KeyKeypadMinus = 0x004a,
  KeyKeypad4 = 0x004b,
  KeyKeypad5 = 0x004c,
  KeyKeypad6 = 0x004d,
  KeyKeypadPlus = 0x004e,
  KeyKeypad1 = 0x004f,
  KeyKeypad2 = 0x0050,
  KeyKeypad3 = 0x0051,
  KeyKeypad0 = 0x0052,
  KeyKeypadDot = 0x0053,
  KeyZenkakuHankaku = 0x0055,
  Key102ND = 0x0056,
  KeyF11 = 0x0057,
  KeyF12 = 0x0058,
  KeyRO = 0x0059,
  KeyKatakana = 0x005a,
  KeyHiragana = 0x005b,
  KeyHenkan = 0x005c,
  KeyKatakanaHiragana = 0x005d,
  KeyMuhenkan = 0x005e,
  KeyKeypadJPComma = 0x005f,
  KeyKeypadEnter = 0x0060,
  KeyRightControl = 0x0061,
  KeyKeypadSlash = 0x0062,
  KeySystemRequest = 0x0063,
  KeyRightAlternate = 0x0064,
  KeyLinefeed = 0x0065,
  KeyHome = 0x0066,
  KeyUp = 0x0067,
  KeyPageUp = 0x0068,
  KeyLeft = 0x0069,
  KeyRight = 0x006a,
  KeyEnd = 0x006b,
  KeyDown = 0x006c,
  KeyPageDown = 0x006d,
  KeyInsert = 0x006e,
  KeyDelete = 0x006f,
  KeyMacro = 0x0070,
  KeyMute = 0x0071,
  KeyVolumeDown = 0x0072,
  KeyVolumeUp = 0x0073,
  KeyPower = 0x0074,
  KeyKeypadEqual = 0x0075,
  KeyKeypadPlusMinus = 0x0076,
  KeyPause = 0x0077,
  KeyScale = 0x0078,
  KeyKeypadComma = 0x0079,
  KeyHangeul = 0x007a,
  KeyHanja = 0x007b,
  KeyYen = 0x007c,
  KeyLeftMeta = 0x007d,
  KeyRightMeta = 0x007e,
  KeyCompose = 0x007f,
  KeyStop = 0x0080,
  KeyAgain = 0x0081,
  KeyProps = 0x0082,
  KeyUndo = 0x0083,
  KeyFront = 0x0084,
  KeyCopy = 0x0085,
  KeyOpen = 0x0086,
  KeyPaste = 0x0087,
  KeyFind = 0x0088,
  KeyCut = 0x0089,
  KeyHelp = 0x008a,
  KeyMenu = 0x008b,
  KeyCalculator = 0x008c,
  KeySetup = 0x008d,
  KeySleep = 0x008e,
  KeyWakeup = 0x008f,
  KeyFile = 0x0090,
  KeySendFile = 0x0091,
  KeyDeleteFile = 0x0092,
  KeyXFER = 0x0093,
  KeyProgram1 = 0x0094,
  KeyProgram2 = 0x0095,
  KeyWWW = 0x0096,
  KeyMsDOS = 0x0097,
  KeyCoffee = 0x0098,
  KeyRotateDisplay = 0x0099,
  KeyCycleWindows = 0x009a,
  KeyMail = 0x009b,
  KeyBookmarks = 0x009c,
  KeyComputer = 0x009d,
  KeyBack = 0x009e,
  KeyForward = 0x009f,
  KeyCloseCD = 0x00a0,
  KeyEjectCD = 0x00a1,
  KeyEjectCloseCD = 0x00a2,
  KeyNextSong = 0x00a3,
  KeyPlayPause = 0x00a4,
  KeyPreviousSong = 0x00a5,
  KeyStopCD = 0x00a6,
  KeyRecord = 0x00a7,
  KeyRewind = 0x00a8,
  KeyPhone = 0x00a9,
  KeyIso = 0x00aa,
  KeyConfig = 0x00ab,
  KeyHomepage = 0x00ac,
  KeyRefresh = 0x00ad,
  KeyExit = 0x00ae,
  KeyMove = 0x00af,
  KeyEdit = 0x00b0,
  KeyScrollUp = 0x00b1,
  KeyScrollDown = 0x00b2,
  KeyKeypadLeftParenthesis = 0x00b3,
  KeyKeypadRightParenthesis = 0x00b4,
  KeyNew = 0x00b5,
  KeyRedo = 0x00b6,
  KeyF13 = 0x00b7,
  KeyF14 = 0x00b8,
  KeyF15 = 0x00b9,
  KeyF16 = 0x00ba,
  KeyF17 = 0x00bb,
  KeyF18 = 0x00bc,
  KeyF19 = 0x00bd,
  KeyF20 = 0x00be,
  KeyF21 = 0x00bf,
  KeyF22 = 0x00c0,
  KeyF23 = 0x00c1,
  KeyF24 = 0x00c2,
  KeyPlayCD = 0x00c8,
  KeyPauseCD = 0x00c9,
  KeyProgram3 = 0x00ca,
  KeyProgram4 = 0x00cb,
  KeyDashboard = 0x00cc,
  KeySuspend = 0x00cd,
  KeyClose = 0x00ce,
  KeyPlay = 0x00cf,
  KeyFastForward = 0x00d0,
  KeyBassBoost = 0x00d1,
  KeyPrint = 0x00d2,
  KeyHP = 0x00d3,
  KeyCamera = 0x00d4,
  KeySound = 0x00d5,
  KeyQuestion = 0x00d6,
  KeyEmail = 0x00d7,
  KeyChat = 0x00d8,
  KeySearch = 0x00d9,
  KeyConnect = 0x00da,
  KeyFinance = 0x00db,
  KeySport = 0x00dc,
  KeyShop = 0x00dd,
  KeyAlternateErase = 0x00de,
  KeyCancel = 0x00df,
  KeyBrightnessDown = 0x00e0,
  KeyBrightnessUp = 0x00e1,
  KeyMedia = 0x00e2,
  KeySwitchVideoMode = 0x00e3,
  KeyKeyboardIlluminationToggle = 0x00e4,
  KeyKeyboardIlluminationDown = 0x00e5,
  KeyKeyboardIlluminationUp = 0x00e6,
  KeySend = 0x00e7,
  KeyReply = 0x00e8,
  KeyForwardMail = 0x00e9,
  KeySave = 0x00ea,
  KeyDocuments = 0x00eb,
  KeyBattery = 0x00ec,
  KeyBluetooth = 0x00ed,
  KeyWLAN = 0x00ee,
  KeyUWB = 0x00ef,
  KeyUnknown = 0x00f0,
  KeyVideoNext = 0x00f1,
  KeyVideoPrevious = 0x00f2,
  KeyBrightnessCycle = 0x00f3,
  KeyBrightnessAuto = 0x00f4,
  KeyDisplayOff = 0x00f5,
  KeyWWAN = 0x00f6,
  KeyRFKill = 0x00f7,
  KeyMicrophoneMute = 0x00f8,
  Button0 = 0x0100,
  Button1 = 0x0101,
  Button2 = 0x0102,
  Button3 = 0x0103,
  Button4 = 0x0104,
  Button5 = 0x0105,
  Button6 = 0x0106,
  Button7 = 0x0107,
  Button8 = 0x0108,
  Button9 = 0x0109,
  ButtonLeftMouse = 0x0110,
  ButtonRightMouse = 0x0111,
  ButtonMiddleMouse = 0x0112,
  ButtonSideMouse = 0x0113,
  ButtonExtraMouse = 0x0114,
  ButtonForwardMouse = 0x0115,
  ButtonBackMouse = 0x0116,
  ButtonTaskMouse = 0x0117,
  ButtonTrigger = 0x0120,
  ButtonThumb = 0x0121,
  ButtonThumb2 = 0x0122,
  ButtonTop = 0x0123,
  ButtonTop2 = 0x0124,
  ButtonPinkie = 0x0125,
  ButtonBase = 0x0126,
  ButtonBase2 = 0x0127,
  ButtonBase3 = 0x0128,
  ButtonBase4 = 0x0129,
  ButtonBase5 = 0x012a,
  ButtonBase6 = 0x012b,
  ButtonDead = 0x012f,
  ButtonSouth = 0x0130,
  ButtonEast = 0x0131,
  ButtonC = 0x0132,
  ButtonNorth = 0x0133,
  ButtonWest = 0x0134,
  ButtonZ = 0x0135,
  ButtonTriggerLeft = 0x0136,
  ButtonTriggerRight = 0x0137,
  ButtonTriggerLeft2 = 0x0138,
  ButtonTriggerRight2 = 0x0139,
  ButtonSelect = 0x013a,
  ButtonStart = 0x013b,
  ButtonMode = 0x013c,
  ButtonThumbLeft = 0x013d,
  ButtonThumbRight = 0x013e,
  ButtonToolPen = 0x0140,
  ButtonToolRubber = 0x0141,
  ButtonToolBrush = 0x0142,
  ButtonToolPencil = 0x0143,
  ButtonToolAirbrush = 0x0144,
  ButtonToolFinger = 0x0145,
  ButtonToolMouse = 0x0146,
  ButtonToolLens = 0x0147,
  ButtonToolQuintupleTap = 0x0148,
  ButtonStylus3 = 0x0149,
  ButtonTouch = 0x014a,
  ButtonStylus = 0x014b,
  ButtonStylus2 = 0x014c,
  ButtonToolDoubleTap = 0x014d,
  ButtonToolTripleTap = 0x014e,
  ButtonToolQuadrupleTap = 0x014f,
  ButtonGearDown = 0x0150,
  ButtonGearUp = 0x0151,
  KeyOk = 0x0160,
  KeySelect = 0x0161,
  KeyGoto = 0x0162,
  KeyClear = 0x0163,
  KeyPower2 = 0x0164,
  KeyOption = 0x0165,
  KeyInfo = 0x0166,
  KeyTime = 0x0167,
  KeyVendor = 0x0168,
  KeyArchive = 0x0169,
  KeyProgram = 0x016a,
  KeyChannel = 0x016b,
  KeyFavorites = 0x016c,
  KeyEPG = 0x016d,
  KeyPVR = 0x016e,
  KeyMHP = 0x016f,
  KeyLanguage = 0x0170,
  KeyTitle = 0x0171,
  KeySubtitle = 0x0172,
  KeyAngle = 0x0173,
  KeyFullScreen = 0x0174,
  KeyMode = 0x0175,
  KeyKeyboard = 0x0176,
  KeyAspectRatio = 0x0177,
  KeyPC = 0x0178,
  KeyTV = 0x0179,
  KeyTV2 = 0x017a,
  KeyVCR = 0x017b,
  KeyVCR2 = 0x017c,
  KeySatellite = 0x017d,
  KeySatellite2 = 0x017e,
  KeyCD = 0x017f,
  KeyTape = 0x0180,
  KeyRadio = 0x0181,
  KeyTuner = 0x0182,
  KeyPlayer = 0x0183,
  KeyText = 0x0184,
  KeyDVD = 0x0185,
  KeyAux = 0x0186,
  KeyMP3 = 0x0187,
  KeyAudio = 0x0188,
  KeyVideo = 0x0189,
  KeyDirectory = 0x018a,
  KeyList = 0x018b,
  KeyMemo = 0x018c,
  KeyCalendar = 0x018d,
  KeyRed = 0x018e,
  KeyGreen = 0x018f,
  KeyYellow = 0x0190,
  KeyBlue = 0x0191,
  KeyChannelUp = 0x0192,
  KeyChannelDown = 0x0193,
  KeyFirst = 0x0194,
  KeyLast = 0x0195,
  KeyAb = 0x0196,
  KeyNext = 0x0197,
  KeyRestart = 0x0198,
  KeySlow = 0x0199,
  KeyShuffle = 0x019a,
  KeyBreak = 0x019b,
  KeyPrevious = 0x019c,
  KeyDigits = 0x019d,
  KeyTeen = 0x019e,
  KeyTwenty = 0x019f,
  KeyVideophone = 0x01a0,
  KeyGames = 0x01a1,
  KeyZoomIn = 0x01a2,
  KeyZoomOut = 0x01a3,
  KeyZoomReset = 0x01a4,
  KeyWordProcessor = 0x01a5,
  KeyEditor = 0x01a6,
  KeySpreadSheet = 0x01a7,
  KeyGraphicsEditor = 0x01a8,
  KeyPresentation = 0x01a9,
  KeyDatabase = 0x01aa,
  KeyNews = 0x01ab,
  KeyVoiceMail = 0x01ac,
  KeyAddressBook = 0x01ad,
  KeyMessenger = 0x01ae,
  KeyDisplayToggle = 0x01af,
  KeySpellcheck = 0x01b0,
  KeyLogoff = 0x01b1,
  KeyDollar = 0x01b2,
  KeyEuro = 0x01b3,
  KeyFrameBack = 0x01b4,
  KeyFrameForward = 0x01b5,
  KeyContextMenu = 0x01b6,
  KeyMediaRepeat = 0x01b7,
  Key10ChannelsUp = 0x01b8,
  Key10ChannelsDown = 0x01b9,
  KeyImages = 0x01ba,
  KeyDeleteEOL = 0x01c0,
  KeyDeleteEOS = 0x01c1,
  KeyInsertLine = 0x01c2,
  KeyDeleteLine = 0x01c3,
  KeyFunction = 0x01d0,
  KeyFunctionEscape = 0x01d1,
  KeyFunctionF1 = 0x01d2,
  KeyFunctionF2 = 0x01d3,
  KeyFunctionF3 = 0x01d4,
  KeyFunctionF4 = 0x01d5,
  KeyFunctionF5 = 0x01d6,
  KeyFunctionF6 = 0x01d7,
  KeyFunctionF7 = 0x01d8,
  KeyFunctionF8 = 0x01d9,
  KeyFunctionF9 = 0x01da,
  KeyFunctionF10 = 0x01db,
  KeyFunctionF11 = 0x01dc,
  KeyFunctionF12 = 0x01dd,
  KeyFunction1 = 0x01de,
  KeyFunction2 = 0x01df,
  KeyFunctionD = 0x01e0,
  KeyFunctionE = 0x01e1,
  KeyFunctionF = 0x01e2,
  KeyFunctionS = 0x01e3,
  KeyFunctionB = 0x01e4,
  KeyBrailleDot1 = 0x01f1,
  KeyBrailleDot2 = 0x01f2,
  KeyBrailleDot3 = 0x01f3,
  KeyBrailleDot4 = 0x01f4,
  KeyBrailleDot5 = 0x01f5,
  KeyBrailleDot6 = 0x01f6,
  KeyBrailleDot7 = 0x01f7,
  KeyBrailleDot8 = 0x01f8,
  KeyBrailleDot9 = 0x01f9,
  KeyBrailleDot10 = 0x01fa,
  KeyNumeric0 = 0x0200,
  KeyNumeric1 = 0x0201,
  KeyNumeric2 = 0x0202,
  KeyNumeric3 = 0x0203,
  KeyNumeric4 = 0x0204,
  KeyNumeric5 = 0x0205,
  KeyNumeric6 = 0x0206,
  KeyNumeric7 = 0x0207,
  KeyNumeric8 = 0x0208,
  KeyNumeric9 = 0x0209,
  KeyNumericStar = 0x020a,
  KeyNumericPound = 0x020b,
  KeyNumericA = 0x020c,
  KeyNumericB = 0x020d,
  KeyNumericC = 0x020e,
  KeyNumericD = 0x020f,
  KeyCameraFocus = 0x0210,
  KeyWPSButton = 0x0211,
  KeyTouchpadToggle = 0x0212,
  KeyTouchpadOn = 0x0213,
  KeyTouchpadOff = 0x0214,
  KeyCameraZoomIn = 0x0215,
  KeyCameraZoomOut = 0x0216,
  KeyCameraUp = 0x0217,
  KeyCameraDown = 0x0218,
  KeyCameraLeft = 0x0219,
  KeyCameraRight = 0x021a,
  KeyAttendantOn = 0x021b,
  KeyAttendantOff = 0x021c,
  KeyAttendantToggle = 0x021d,
  KeyLightsToggle = 0x021e,
  ButtonDPadUp = 0x0220,
  ButtonDPadDown = 0x0221,
  ButtonDPadLeft = 0x0222,
  ButtonDPadRight = 0x0223,
  KeyALSToggle = 0x0230,
  KeyRotateLockToggle = 0x0231,
  KeyButtonConfiguration = 0x0240,
  KeyTaskManager = 0x0241,
  KeyJournal = 0x0242,
  KeyControlPanel = 0x0243,
  KeyAppSelect = 0x0244,
  KeyScreenSaver = 0x0245,
  KeyVoiceCommand = 0x0246,
  KeyAssistant = 0x0247,
  KeyBrightnessMin = 0x0250,
  KeyBrightnessMax = 0x0251,
  KeyKeyboardInputAssistPrevious = 0x0260,
  KeyKeyboardInputAssistNext = 0x0261,
  KeyKeyboardInputAssistPreviousGroup = 0x0262,
  KeyKeyboardInputAssistNextGroup = 0x0263,
  KeyKeyboardInputAssistAccept = 0x0264,
  KeyKeyboardInputAssistCancel = 0x0265,
  KeyRightUp = 0x0266,
  KeyRightDown = 0x0267,
  KeyLeftUp = 0x0268,
  KeyLeftDown = 0x0269,
  KeyRootMenu = 0x026a,
  KeyMediaTopMenu = 0x026b,
  KeyNumeric11 = 0x026c,
  KeyNumeric12 = 0x026d,
  KeyAudioDescription = 0x026e,
  Key3DMode = 0x026f,
  KeyNextFavorite = 0x0270,
  KeyStopRecord = 0x0271,
  KeyPauseRecord = 0x0272,
  KeyVOD = 0x0273,
  KeyUnmute = 0x0274,
  KeyFastReverse = 0x0275,
  KeySlowReverse = 0x0276,
  KeyData = 0x0277,
  KeyOnScreenKeyboard = 0x0278,
  ButtonTriggerHappy1 = 0x02c0,
  ButtonTriggerHappy2 = 0x02c1,
  ButtonTriggerHappy3 = 0x02c2,
  ButtonTriggerHappy4 = 0x02c3,
  ButtonTriggerHappy5 = 0x02c4,
  ButtonTriggerHappy6 = 0x02c5,
  ButtonTriggerHappy7 = 0x02c6,
  ButtonTriggerHappy8 = 0x02c7,
  ButtonTriggerHappy9 = 0x02c8,
  ButtonTriggerHappy10 = 0x02c9,
  ButtonTriggerHappy11 = 0x02ca,
  ButtonTriggerHappy12 = 0x02cb,
  ButtonTriggerHappy13 = 0x02cc,
  ButtonTriggerHappy14 = 0x02cd,
  ButtonTriggerHappy15 = 0x02ce,
  ButtonTriggerHappy16 = 0x02cf,
  ButtonTriggerHappy17 = 0x02d0,
  ButtonTriggerHappy18 = 0x02d1,
  ButtonTriggerHappy19 = 0x02d2,
  ButtonTriggerHappy20 = 0x02d3,
  ButtonTriggerHappy21 = 0x02d4,
  ButtonTriggerHappy22 = 0x02d5,
  ButtonTriggerHappy23 = 0x02d6,
  ButtonTriggerHappy24 = 0x02d7,
  ButtonTriggerHappy25 = 0x02d8,
  ButtonTriggerHappy26 = 0x02d9,
  ButtonTriggerHappy27 = 0x02da,
  ButtonTriggerHappy28 = 0x02db,
  ButtonTriggerHappy29 = 0x02dc,
  ButtonTriggerHappy30 = 0x02dd,
  ButtonTriggerHappy31 = 0x02de,
  ButtonTriggerHappy32 = 0x02df,
  ButtonTriggerHappy33 = 0x02e0,
  ButtonTriggerHappy34 = 0x02e1,
  ButtonTriggerHappy35 = 0x02e2,
  ButtonTriggerHappy36 = 0x02e3,
  ButtonTriggerHappy37 = 0x02e4,
  ButtonTriggerHappy38 = 0x02e5,
  ButtonTriggerHappy39 = 0x02e6,
  ButtonTriggerHappy40 = 0x02e7,
  Max = 0x02ff,
  Count = Key::Max + 0x0001,
};

/*constexpr*/ auto
operator<<(std::ostream& os, Key key) noexcept -> std::ostream&;
} // namespace engine::input